﻿using System.Data;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// XML 파일 경로
        /// </summary>
        private string xmlFilePath = @"..\..\Contacts.xml";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.gridControl.ItemsSource = LoadData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Save XML 버튼 클릭시 처리하기 - saveXMLButton_Click(sender, e)

        /// <summary>
        /// Save XML 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void saveXMLButton_Click(object sender, RoutedEventArgs e)
        {
            SaveData();

            MessageBox.Show("Changes have been successfully saved to an XML file.", "Info");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 데이터 로드하기 - LoadData()

        /// <summary>
        /// 데이터 로드하기
        /// </summary>
        /// <returns>데이터 테이블</returns>
        private DataTable LoadData()
        {
            DataSet dataSet = new DataSet();

            dataSet.ReadXml(this.xmlFilePath);

            return dataSet.Tables[0];
        }

        #endregion
        #region 데이터 저장하기 - SaveData()

        /// <summary>
        /// 데이터 저장하기
        /// </summary>
        private void SaveData()
        {
            ((DataTable)this.gridControl.ItemsSource).DataSet.WriteXml(this.xmlFilePath);
        }

        #endregion
    }
}